Index: LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 1795)
@@ -63,5 +63,7 @@
 !$OMP THREADPRIVATE(ratqs)
       REAL, ALLOCATABLE, SAVE :: pbl_tke(:,:,:) ! turb kinetic energy
-!$OMP THREADPRIVATE(pbl_tke)
+      REAL, ALLOCATABLE, SAVE :: coefh(:,:,:) ! Kz enthalpie
+      REAL, ALLOCATABLE, SAVE :: coefm(:,:,:) ! Kz momentum
+!$OMP THREADPRIVATE(pbl_tke, coefh,coefm)
       REAL, ALLOCATABLE, SAVE :: zmax0(:), f0(:) ! 
 !$OMP THREADPRIVATE(zmax0,f0)
@@ -359,8 +361,9 @@
 !======================================================================
 SUBROUTINE phys_state_var_init(read_climoz)
-use dimphy
+USE dimphy
 USE control_mod
-use aero_mod
-use infotrac, ONLY : nbtr
+USE aero_mod
+USE infotrac, ONLY : nbtr
+USE indice_sol_mod
 IMPLICIT NONE
 
@@ -373,5 +376,4 @@
 ! climatology and the daylight climatology
 
-#include "indicesol.h"
       ALLOCATE(rlat(klon), rlon(klon))
       ALLOCATE(pctsrf(klon,nbsrf))
@@ -394,5 +396,7 @@
       ALLOCATE(clwcon(klon,klev),rnebcon(klon,klev))
       ALLOCATE(ratqs(klon,klev))
-      ALLOCATE(pbl_tke(klon,klev+1,nbsrf))
+      ALLOCATE(pbl_tke(klon,klev+1,nbsrf+1))
+      ALLOCATE(coefh(klon,klev+1,nbsrf+1))
+      ALLOCATE(coefm(klon,klev+1,nbsrf+1))
       ALLOCATE(zmax0(klon), f0(klon))
       ALLOCATE(ema_work1(klon,klev), ema_work2(klon,klev))
@@ -518,8 +522,8 @@
 !======================================================================
 SUBROUTINE phys_state_var_end
-use dimphy
-use control_mod
+USE dimphy
+USE control_mod
+USE indice_sol_mod
 IMPLICIT NONE
-#include "indicesol.h"
 
       deallocate(rlat, rlon, pctsrf, ftsol, falb1, falb2)
@@ -530,5 +534,5 @@
       deallocate(        u_ancien, v_ancien                 )
       deallocate(        tr_ancien)                           !RomP
-      deallocate(ratqs, pbl_tke)
+      deallocate(ratqs, pbl_tke,coefh,coefm)
       deallocate(zmax0, f0)
       deallocate(ema_work1, ema_work2)
Index: LMDZ5/branches/testing/libf/phylmd/physiq.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/physiq.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/physiq.F	(revision 1795)
@@ -31,9 +31,12 @@
       USE fonte_neige_mod, ONLY  : fonte_neige_get_vars
       USE phys_output_mod
+      USE phys_output_ctrlout_mod
+      USE iophy
       use open_climoz_m, only: open_climoz ! ozone climatology from a file
       use regr_pr_av_m, only: regr_pr_av
       use netcdf95, only: nf95_close
 cIM for NMC files
-      use netcdf, only: nf90_fill_real
+c     use netcdf, only: nf90_fill_real
+      use netcdf
       use mod_phys_lmdz_mpi_data, only: is_mpi_root
       USE aero_mod
@@ -45,55 +48,55 @@
       USE CHEM_REP, ONLY : Init_chem_rep_xjour
 #endif
-
+      USE indice_sol_mod
 
 !IM stations CFMIP
       USE CFMIP_point_locations
       IMPLICIT none
-c======================================================================
-c
-c Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
-c
-c Objet: Moniteur general de la physique du modele
-cAA      Modifications quant aux traceurs :
-cAA                  -  uniformisation des parametrisations ds phytrac
-cAA                  -  stockage des moyennes des champs necessaires
-cAA                     en mode traceur off-line 
-c======================================================================
-c   CLEFS CPP POUR LES IO
-c   =====================
+!>======================================================================
+!!
+!! Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
+!!
+!! Objet: Moniteur general de la physique du modele
+!!AA      Modifications quant aux traceurs :
+!!AA                  -  uniformisation des parametrisations ds phytrac
+!!AA                  -  stockage des moyennes des champs necessaires
+!!AA                     en mode traceur off-line 
+!!======================================================================
+!!   CLEFS CPP POUR LES IO
+!!   =====================
 #define histNMC
 c#define histISCCP
-c======================================================================
-c    modif   ( P. Le Van ,  12/10/98 )
-c
-c  Arguments:
-c
-c nlon----input-I-nombre de points horizontaux
-c nlev----input-I-nombre de couches verticales, doit etre egale a klev
-c debut---input-L-variable logique indiquant le premier passage
-c lafin---input-L-variable logique indiquant le dernier passage
-c jD_cur       -R-jour courant a l'appel de la physique (jour julien)
-c jH_cur       -R-heure courante a l'appel de la physique (jour julien)
-c pdtphys-input-R-pas d'integration pour la physique (seconde)
-c paprs---input-R-pression pour chaque inter-couche (en Pa)
-c pplay---input-R-pression pour le mileu de chaque couche (en Pa)
-c pphi----input-R-geopotentiel de chaque couche (g z) (reference sol)
-c pphis---input-R-geopotentiel du sol
-c presnivs-input_R_pressions approximat. des milieux couches ( en PA)
-c u-------input-R-vitesse dans la direction X (de O a E) en m/s
-c v-------input-R-vitesse Y (de S a N) en m/s
-c t-------input-R-temperature (K)
-c qx------input-R-humidite specifique (kg/kg) et d'autres traceurs
-c d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
-c d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
-c flxmass_w -input-R- flux de masse verticale
-c d_u-----output-R-tendance physique de "u" (m/s/s)
-c d_v-----output-R-tendance physique de "v" (m/s/s)
-c d_t-----output-R-tendance physique de "t" (K/s)
-c d_qx----output-R-tendance physique de "qx" (kg/kg/s)
-c d_ps----output-R-tendance physique de la pression au sol
-cIM
-c PVteta--output-R-vorticite potentielle a des thetas constantes
-c======================================================================
+!!======================================================================
+!!    modif   ( P. Le Van ,  12/10/98 )
+!!
+!!  Arguments:
+!!
+!! nlon----input-I-nombre de points horizontaux
+!! nlev----input-I-nombre de couches verticales, doit etre egale a klev
+!! debut---input-L-variable logique indiquant le premier passage
+!! lafin---input-L-variable logique indiquant le dernier passage
+!! jD_cur       -R-jour courant a l'appel de la physique (jour julien)
+!! jH_cur       -R-heure courante a l'appel de la physique (jour julien)
+!! pdtphys-input-R-pas d'integration pour la physique (seconde)
+!! paprs---input-R-pression pour chaque inter-couche (en Pa)
+!! pplay---input-R-pression pour le mileu de chaque couche (en Pa)
+!! pphi----input-R-geopotentiel de chaque couche (g z) (reference sol)
+!! pphis---input-R-geopotentiel du sol
+!! presnivs-input_R_pressions approximat. des milieux couches ( en PA)
+!! u-------input-R-vitesse dans la direction X (de O a E) en m/s
+!! v-------input-R-vitesse Y (de S a N) en m/s
+!! t-------input-R-temperature (K)
+!! qx------input-R-humidite specifique (kg/kg) et d'autres traceurs
+!! d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
+!! d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
+!! flxmass_w -input-R- flux de masse verticale
+!! d_u-----output-R-tendance physique de "u" (m/s/s)
+!! d_v-----output-R-tendance physique de "v" (m/s/s)
+!! d_t-----output-R-tendance physique de "t" (K/s)
+!! d_qx----output-R-tendance physique de "qx" (kg/kg/s)
+!! d_ps----output-R-tendance physique de la pression au sol
+!!IM
+!! PVteta--output-R-vorticite potentielle a des thetas constantes
+!!======================================================================
 #include "dimensions.h"
       integer jjmp1
@@ -103,5 +106,4 @@
 
 #include "regdim.h"
-#include "indicesol.h"
 #include "dimsoil.h"
 #include "clesphys.h"
@@ -218,5 +220,9 @@
       REAL u(klon,klev)
       REAL v(klon,klev)
-      REAL t(klon,klev),theta(klon,klev)
+      REAL t(klon,klev),theta(klon,klev),thetal(klon,klev)
+c thetal: ligne suivante a decommenter si vous avez les fichiers     MPL 20130625
+c fth_fonctions.F90 et parkind1.F90
+c sinon thetal=theta
+c     REAL fth_thetae,fth_thetav,fth_thetal
       REAL qx(klon,klev,nqtot)
       REAL flxmass_w(klon,klev)
@@ -642,7 +648,7 @@
       REAL zw2(klon,klev+1)
       REAL fraca(klon,klev+1)        
-      REAL ztv(klon,klev) 
+      REAL ztv(klon,klev),ztva(klon,klev)
       REAL zpspsk(klon,klev)
-      REAL ztla(klon,klev) 
+      REAL ztla(klon,klev),zqla(klon,klev) 
       REAL zthl(klon,klev)
 
@@ -655,4 +661,5 @@
       real w0(klon)                                          ! Vitesse des thermiques au LCL
       real w_conv(klon)                                      ! Vitesse verticale de grande \'echelle au LCL
+      real tke0(klon,klev+1)                                 ! TKE au début du pas de temps
       real therm_tke_max0(klon)                              ! TKE dans les thermiques au LCL 
       real env_tke_max0(klon)                                ! TKE dans l'environnement au LCL 
@@ -694,7 +701,4 @@
 cAA
 cAA  Pour phytrac 
-cAA
-      REAL coefh(klon,klev)     ! coef d'echange pour phytrac, valable pour 2<=k<=klev
-      REAL coefm(klon,klev)     ! coef d'echange pour U, V
       REAL u1(klon)             ! vents dans la premiere couche U
       REAL v1(klon)             ! vents dans la premiere couche V
@@ -722,4 +726,5 @@
 
       REAL bils(klon) ! bilan de chaleur au sol
+
       REAL wfbilo(klon,nbsrf) ! bilan d'eau, pour chaque
 C                             ! type de sous-surface et pondere par la fraction
@@ -751,5 +756,5 @@
       SAVE lmt_pas                ! frequence de mise a jour
 c$OMP THREADPRIVATE(lmt_pas) 
-      real zmasse(klon, llm) 
+      real zmasse(klon, llm),exner(klon, llm) 
 C     (column-density of mass of air in a cell, in kg m-2)
       real, parameter:: dobson_u = 2.1415e-05 ! Dobson unit, in kg m-2
@@ -1058,5 +1063,5 @@
      .           prof2d_av = 3, prof3d_av = 4)
       character*30 nom_fichier
-      character*10 varname
+      character*40 varname
       character*40 vartitle
       character*20 varunits
@@ -1121,5 +1126,9 @@
       LOGICAL, SAVE :: new_aod
 c$OMP THREADPRIVATE(new_aod) 
-   
+c
+c--STRAT AEROSOL
+      LOGICAL, SAVE :: flag_aerosol_strat
+c$OMP THREADPRIVATE(flag_aerosol_strat)
+cc-fin STRAT AEROSOL
 c
 c Declaration des constantes et des fonctions thermodynamiques
@@ -1271,5 +1280,5 @@
      .     iflag_cldcon,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs,
      .     ok_ade, ok_aie, ok_cdnc, aerosol_couple, 
-     .     flag_aerosol, new_aod,
+     .     flag_aerosol, flag_aerosol_strat, new_aod,
      .     bl95_b0, bl95_b1,
 c     nv flags pour la convection et les poches froides
@@ -1287,6 +1296,4 @@
           pbase=0
 cIM 180608
-c         pmflxr=0.
-c         pmflxs=0.
 
         itau_con=0
@@ -1395,4 +1402,9 @@
 
          CALL phyetat0 ("startphy.nc",clesphy0,tabcntr0)
+         IF (klon_glo==1) THEN
+         coefh=0. ; coefm=0. ; pbl_tke=0.
+         coefh(:,2,:)=1.e-2 ; coefm(:,2,:)=1.e-2 ; pbl_tke(:,2,:)=1.e-2
+         PRINT*,'FH WARNING : lignes a supprimer'
+         ENDIF
 cIM begin
           print*,'physiq: clwcon rnebcon ratqs',clwcon(1,1),rnebcon(1,1)
@@ -1593,6 +1605,6 @@
      &                       ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, 
      &                       read_climoz, phys_out_filestations,
-     &                       new_aod, aerosol_couple
-     &                        )
+     &                       new_aod, aerosol_couple,
+     &                       flag_aerosol_strat )
 c$OMP END MASTER
 c$OMP BARRIER
@@ -1769,4 +1781,6 @@
       d1a(:,:)=0.
       dam(:,:)=0.
+          pmflxr=0.
+          pmflxs=0.
 ! RomP <<<
 
@@ -1784,4 +1798,5 @@
       ENDDO
       ENDDO
+      tke0(:,:)=pbl_tke(:,:,is_ave)
       IF (nqtot.GE.3) THEN
       DO iq = 3, nqtot
@@ -2072,5 +2087,5 @@
      s     albsol1,   albsol2,   sens,    evap,  
      s     zxtsol,    zxfluxlat, zt2m,    qsat2m, 
-     s     d_t_vdf,   d_q_vdf,   d_u_vdf, d_v_vdf,
+     s     d_t_vdf,   d_q_vdf,   d_u_vdf, d_v_vdf, d_t_diss,
      s     coefh,     coefm,     slab_wfbils,                
      d     qsol,      zq2m,      s_pblh,  s_lcl,
@@ -2088,5 +2103,6 @@
 !-----------------------------------------------------------------------------------------
 ! ajout des tendances de la diffusion turbulente
-      CALL add_phys_tend(d_u_vdf,d_v_vdf,d_t_vdf,d_q_vdf,dql0,'vdf')
+      CALL add_phys_tend
+     s     (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,'vdf')
 !-----------------------------------------------------------------------------------------
 
@@ -2658,5 +2674,5 @@
      s      ,alp_bl_conv,alp_bl_stat
 ccc fin nrlmd le 10/04/2012
-     s                 )
+     s      ,zqla,ztva )
 
 ccc nrlmd le 10/04/2012
@@ -2966,4 +2982,12 @@
          cg_aero(:,:,:,:)  = 0.
       ENDIF
+c
+c--STRAT AEROSOL
+c--updates tausum_aero,tau_aero,piz_aero,cg_aero
+      IF (flag_aerosol_strat) THEN
+         PRINT *,'appel a readaerosolstrat', mth_cur
+         CALL readaerosolstrato(debut)
+      ENDIF
+c--fin STRAT AEROSOL
 
 cIM calcul nuages par le simulateur ISCCP
@@ -3174,5 +3198,5 @@
      $                          paprs,
      $                          pplay,
-     $                          coefh,
+     $                          coefh(:,:,is_ave),
      $                          pphi,
      $                          t_seri,
@@ -3353,5 +3377,6 @@
      e        t_seri,q_seri,wo,
      e        cldfrarad, cldemirad, cldtaurad,
-     e        ok_ade, ok_aie, flag_aerosol,
+     e        ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol,
+     e        flag_aerosol_strat,
      e        tau_aero, piz_aero, cg_aero,
      e        cldtaupirad,new_aod,
@@ -3395,5 +3420,6 @@
      e        t_seri,q_seri,wo,
      e        cldfra, cldemi, cldtau,
-     e        ok_ade, ok_aie, flag_aerosol,
+     e        ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol,
+     e        flag_aerosol_strat,
      e        tau_aero, piz_aero, cg_aero,
      e        cldtaupi,new_aod,
@@ -3431,4 +3457,12 @@
          solsw=0.
          radsol=0.
+         swup=0.    ! MPL 27102011 pour les fichiers AMMA_profiles et AMMA_scalars
+         swup0=0.
+         swdn=0.
+         swdn0=0.
+         lwup=0.
+         lwup0=0.
+         lwdn=0.
+         lwdn0=0.
       END IF
 
@@ -3695,5 +3729,5 @@
      I     paprs,    pplay,     pmfu,     pmfd,
      I     pen_u,    pde_u,     pen_d,    pde_d,
-     I     cdragh,   coefh,     fm_therm, entr_therm,
+     I     cdragh,   coefh(:,:,is_ave),     fm_therm, entr_therm,
      I     u1,       v1,        ftsol,    pctsrf,
      I     ustar,     u10m,      v10m,
@@ -3722,5 +3756,5 @@
      I                   t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
      I                   fm_therm,entr_therm,
-     I                   cdragh,coefh,u1,v1,ftsol,pctsrf,
+     I                   cdragh,coefh(:,:,is_ave),u1,v1,ftsol,pctsrf,
      I                   frac_impa, frac_nucl,
      I                   pphis,airephy,dtime,itap,
@@ -3748,20 +3782,17 @@
 c Accumuler les variables a stocker dans les fichiers histoire:
 c
-c+jld ec_conser
-      DO k = 1, klev
-      DO i = 1, klon
-        ZRCPD = RCPD*(1.0+RVTMP2*q_seri(i,k))
-        d_t_ec(i,k)=0.5/ZRCPD
-     $      *(u(i,k)**2+v(i,k)**2-u_seri(i,k)**2-v_seri(i,k)**2)
-      ENDDO
-      ENDDO
-
-      DO k = 1, klev
-      DO i = 1, klon
-        t_seri(i,k)=t_seri(i,k)+d_t_ec(i,k)
-        d_t_ec(i,k) = d_t_ec(i,k)/dtime
-       END DO 
-      END DO 
-c-jld ec_conser
+
+!================================================================
+! Conversion of kinetic and potential energy into heat, for
+! parameterisation of subgrid-scale motions
+!================================================================
+
+      d_t_ec(:,:)=0.
+      forall (k=1: llm) exner(:, k) = (pplay(:, k)/paprs(:,1))**RKAPPA
+      CALL ener_conserv(klon,klev,pdtphys,u,v,t,qx(:,:,ivap),
+     s        u_seri,v_seri,t_seri,q_seri,pbl_tke(:,:,is_ave)-tke0(:,:),
+     s        zmasse,exner,d_t_ec)
+      t_seri(:,:)=t_seri(:,:)+d_t_ec(:,:)
+
 cIM
       IF (ip_ebil_phy.ge.1) THEN 
@@ -3833,5 +3864,5 @@
       END IF
 
-c=============================================================
+
 c
 c Convertir les incrementations en tendances
@@ -3946,4 +3977,10 @@
 cJYG/IM theta en fin de pas de temps de physique
         theta(i,k)=t_seri(i,k)*(100000./pplay(i,k))**(RD/RCPD)
+c thetal: 2 lignes suivantes a decommenter si vous avez les fichiers     MPL 20130625
+c fth_fonctions.F90 et parkind1.F90
+c sinon thetal=theta
+c       thetal(i,k)=fth_thetal(pplay(i,k),t_seri(i,k),q_seri(i,k),
+c    :         ql_seri(i,k))
+        thetal(i,k)=theta(i,k)
       ENDDO
       ENDDO
@@ -3962,4 +3999,5 @@
       CALL fonte_neige_get_vars(pctsrf, 
      .     zxfqcalving, zxfqfonte, zxffonte)
+
 
 
@@ -3993,6 +4031,8 @@
       endif
 
- 
-#include "phys_output_write.h"
+#include "phys_output_write_new.h"
+
+
+
 
 #ifdef histISCCP
@@ -4072,5 +4112,4 @@
          ENDIF !if callstats
      
-
       IF (lafin) THEN
          itau_phy = itau_phy + itap
Index: LMDZ5/branches/testing/libf/phylmd/phystokenc.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phystokenc.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/phystokenc.F90	(revision 1795)
@@ -12,4 +12,5 @@
   USE iophy
   USE control_mod
+  USE indice_sol_mod
   
   IMPLICIT NONE
@@ -22,5 +23,4 @@
   INCLUDE "dimensions.h"
   INCLUDE "tracstoke.h"
-  INCLUDE "indicesol.h"
   INCLUDE "iniprint.h"
 !======================================================================
Index: LMDZ5/branches/testing/libf/phylmd/phytrac.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phytrac.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/phytrac.F90	(revision 1795)
@@ -45,4 +45,5 @@
   USE tracreprobus_mod
   USE control_mod
+  USE indice_sol_mod
 
   IMPLICIT NONE
@@ -50,5 +51,4 @@
   INCLUDE "YOMCST.h"
   INCLUDE "dimensions.h"
-  INCLUDE "indicesol.h"
   INCLUDE "clesphys.h"
   INCLUDE "temps.h"
@@ -203,6 +203,6 @@
   INTEGER                   :: itau_w      ! pas de temps ecriture = nstep + itau_phy
   LOGICAL,PARAMETER         :: ok_sync=.TRUE.
-  CHARACTER(len=20)         :: chtratimestep 
-
+  CHARACTER(len=20),save    :: chtratimestep,chtratimestep_omp
+!$OMP THREADPRIVATE(chtratimestep)
 !
 ! Nature du traceur
@@ -264,6 +264,6 @@
   CHARACTER(len=8),DIMENSION(nbtr) :: solsym
 !RomP >>>
-  INTEGER,SAVE  :: iflag_lscav
-  LOGICAL,SAVE  :: convscav
+  INTEGER,SAVE  :: iflag_lscav_omp,iflag_lscav
+  LOGICAL,SAVE  :: convscav_omp,convscav
 !$OMP THREADPRIVATE(iflag_lscav,convscav)
 !RomP <<<
@@ -309,6 +309,10 @@
   IF (debutphy) THEN
 !!jyg
-   chtratimestep='DefFreq'
-   CALL getin('tra_time_step',chtratimestep)
+!$OMP MASTER
+   chtratimestep_omp='DefFreq'
+   CALL getin('tra_time_step',chtratimestep_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+   chtratimestep=chtratimestep_omp
    IF (chtratimestep .NE. 'DefFreq') THEN
      call convers_timesteps(chtratimestep,pdtphys,ecrit_tra)
@@ -321,6 +325,10 @@
 !Config Help = 
 !
-  convscav=.false.
-  call getin('convscav', convscav)
+!$OMP MASTER
+  convscav_omp=.false.
+  call getin('convscav', convscav_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+  convscav=convscav_omp
   print*,'phytrac passage dans routine conv avec lessivage', convscav
 !
@@ -331,6 +339,10 @@
 !Config Help = 
 !
-  iflag_lscav=1
-  call getin('iflag_lscav', iflag_lscav)
+!$OMP MASTER
+  iflag_lscav_omp=1
+  call getin('iflag_lscav', iflag_lscav_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+  iflag_lscav=iflag_lscav_omp
 !
   SELECT CASE(iflag_lscav)
@@ -371,5 +383,5 @@
      INCLUDE "ini_histrac.h"
 #endif
-  END IF
+  END IF ! of IF (debutphy)
 !############################################ END INITIALIZATION #######
 
Index: LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 1795)
@@ -11,4 +11,5 @@
    cldfra, cldemi, cldtaupd,&
    ok_ade, ok_aie, flag_aerosol,&
+   flag_aerosol_strat,&
    tau_aero, piz_aero, cg_aero,&
    cldtaupi, new_aod, &
@@ -57,4 +58,5 @@
   ! ok_aie---input-L- apply the Aerosol Indirect Effect or not?
   ! flag_aerosol-input-I- aerosol flag from 0 to 6
+  ! flag_aerosol_strat-input-I- use stratospheric aerosols flag (T/F)
   ! tau_ae, piz_ae, cg_ae-input-R- aerosol optical properties (calculated in aeropt.F)
   ! cldtaupi-input-R- epaisseur optique des nuages dans le visible
@@ -121,4 +123,5 @@
   LOGICAL, INTENT(in)  :: ok_ade, ok_aie                                 ! switches whether to use aerosol direct (indirect) effects or not
   INTEGER, INTENT(in)  :: flag_aerosol                                   ! takes value 0 (no aerosol) or 1 to 6 (aerosols)
+  LOGICAL, INTENT(in)  :: flag_aerosol_strat                             ! use stratospheric aerosols
   REAL,    INTENT(in)  :: cldfra(KLON,KLEV), cldemi(KLON,KLEV), cldtaupd(KLON,KLEV)
   REAL,    INTENT(in)  :: tau_aero(KLON,KLEV,9,2)                        ! aerosol optical properties (see aeropt.F)
@@ -360,5 +363,5 @@
                ztopswadaero,zsolswadaero,&
                ztopswaiaero,zsolswaiaero,& 
-               ok_ade, ok_aie, flag_aerosol) 
+               ok_ade, ok_aie) 
           
        ELSE ! new_aod=T         
@@ -379,5 +382,5 @@
                zsolsw_aero,zsolsw0_aero,&
                ztopswcf_aero,zsolswcf_aero, & 
-               ok_ade, ok_aie, flag_aerosol) 
+               ok_ade, ok_aie, flag_aerosol,flag_aerosol_strat) 
        ENDIF
 
Index: LMDZ5/branches/testing/libf/phylmd/read_pstoke.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/read_pstoke.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/read_pstoke.F	(revision 1795)
@@ -21,4 +21,5 @@
       USE dimphy
       USE control_mod
+      USE indice_sol_mod
 
        IMPLICIT NONE
@@ -34,5 +35,4 @@
 #include "description.h"
 #include "serre.h"
-#include "indicesol.h"
 cccc#include "dimphy.h"
 	
Index: LMDZ5/branches/testing/libf/phylmd/read_pstoke0.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/read_pstoke0.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/read_pstoke0.F	(revision 1795)
@@ -17,7 +17,8 @@
 C******************************************************************************
 
-	use netcdf
+	 USE netcdf
        USE dimphy
        USE control_mod
+       USE indice_sol_mod
 
        IMPLICIT NONE
@@ -33,5 +34,4 @@
 #include "description.h"
 #include "serre.h"
-#include "indicesol.h"
 cccc#include "dimphy.h"
 	  
Index: LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 1795)
+++ LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 1795)
@@ -0,0 +1,172 @@
+subroutine readaerosolstrato(debut)
+
+    use netcdf95, only: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
+                        nf95_inq_varid, nf95_open
+    use netcdf, only: nf90_get_var, nf90_noerr, nf90_nowrite
+
+    USE phys_cal_mod, ONLY : mth_cur
+    USE mod_grid_phy_lmdz
+    USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+    USE mod_phys_lmdz_para 
+    USE phys_state_var_mod
+    USE phys_local_var_mod
+    USE aero_mod
+    USE dimphy
+
+    implicit none
+
+    include "YOMCST.h"
+    include "dimensions.h"
+
+! Variable input
+    logical debut
+
+! Variables locales
+    integer n_lat   ! number of latitudes in the input data
+    integer n_lon   ! number of longitudes in the input data
+    integer n_lev   ! number of levels in the input data
+    integer n_month ! number of months in the input data
+    real, pointer:: latitude(:)
+    real, pointer:: longitude(:)
+    real, pointer:: time(:)
+    real, pointer:: lev(:)
+    integer i, k, band, wave
+    integer, save :: mth_pre
+
+    real, allocatable, dimension(:,:), save :: tau_aer_strat
+!$OMP THREADPRIVATE(tau_aer_strat)
+
+! Champs reconstitues
+    real, allocatable:: tauaerstrat(:, :, :, :)
+    real, allocatable:: tauaerstrat_mois(:, :, :)
+    real, allocatable:: tauaerstrat_mois_glo(:, :)
+    real, allocatable:: tauaerstrat_mois_glo_bands(:,:,:)
+
+! For NetCDF:
+    integer ncid_in  ! IDs for input files
+    integer varid, ncerr
+
+! Stratospheric aerosols optical properties
+! alpha_strat over the 2 bands is normalised by the 550 nm extinction coefficient
+! alpha_strat_wave is *not* normalised by the 550 nm extinction coefficient
+    real, dimension(nbands) :: alpha_strat, piz_strat, cg_strat
+    data alpha_strat/0.9922547, 0.7114912 /
+    data piz_strat  /0.9999998, 0.99762493/
+    data cg_strat   /0.73107845,0.73229635/
+    real, dimension(nwave) :: alpha_strat_wave
+    data alpha_strat_wave/3.36780953,3.34667683,3.20444202,3.0293026,2.82108808/
+
+!--------------------------------------------------------
+
+    IF (.not.ALLOCATED(tau_aer_strat)) ALLOCATE(tau_aer_strat(klon,klev))
+
+    IF (is_mpi_root) THEN
+
+    IF (debut.OR.mth_cur.NE.mth_pre) THEN
+
+    IF (nbands.NE.2) THEN 
+        print *,'nbands doit etre egal a 2 dans readaerosolstrat'
+        STOP
+    ENDIF
+
+    CALL nf95_open("taustrat.nc", nf90_nowrite, ncid_in)
+
+    CALL nf95_inq_varid(ncid_in, "LEV", varid)
+    CALL nf95_gw_var(ncid_in, varid, lev)
+    n_lev = size(lev)
+    IF (n_lev.NE.klev) THEN 
+       print *,'Le nombre de niveaux n est pas egal a klev'
+       STOP
+    ENDIF
+
+    CALL nf95_inq_varid(ncid_in, "LAT", varid)
+    CALL nf95_gw_var(ncid_in, varid, latitude)
+    n_lat = size(latitude)
+    print *, 'LAT aerosol strato=', n_lat, latitude
+    IF (n_lat.NE.jjm+1) THEN 
+       print *,'Le nombre de lat n est pas egal a jjm+1'
+       STOP
+    ENDIF
+
+    CALL nf95_inq_varid(ncid_in, "LON", varid)
+    CALL nf95_gw_var(ncid_in, varid, longitude)
+    n_lon = size(longitude)
+    print *, 'LON aerosol strato=', n_lon, longitude
+    IF (n_lon.NE.iim) THEN 
+       print *,'Le nombre de lon n est pas egal a iim'
+       STOP
+    ENDIF
+
+    CALL nf95_inq_varid(ncid_in, "TIME", varid)
+    CALL nf95_gw_var(ncid_in, varid, time)
+    n_month = size(time)
+    print *, 'TIME aerosol strato=', n_month, time
+    IF (n_month.NE.12) THEN 
+       print *,'Le nombre de month n est pas egal a 12'
+       STOP
+    ENDIF
+
+    ALLOCATE(tauaerstrat(n_lon, n_lat, n_lev, n_month))
+    ALLOCATE(tauaerstrat_mois(n_lon, n_lat, n_lev))
+    ALLOCATE(tauaerstrat_mois_glo(klon_glo, n_lev))
+    ALLOCATE(tauaerstrat_mois_glo_bands(klon_glo, n_lev,nbands))
+
+!--reading stratospheric AOD at 550 nm
+    CALL nf95_inq_varid(ncid_in, "TAUSTRAT", varid)
+    ncerr = nf90_get_var(ncid_in, varid, tauaerstrat)
+    print *,'code erreur readaerosolstrato=', ncerr, varid
+
+    CALL nf95_close(ncid_in)
+
+!---select the correct month
+    IF (mth_cur.LT.1.OR.mth_cur.GT.12) THEN
+      print *,'probleme avec le mois dans readaerosolstrat =', mth_cur
+    ENDIF
+    tauaerstrat_mois(:,:,:) = tauaerstrat(:,:,:,mth_cur)
+
+!---reduce to a klon_glo grid 
+    CALL grid2dTo1d_glo(tauaerstrat_mois,tauaerstrat_mois_glo)
+
+!--scatter on all proc
+    CALL scatter(tauaerstrat_mois_glo,tau_aer_strat)
+
+    DEALLOCATE(tauaerstrat)
+    DEALLOCATE(tauaerstrat_mois)
+    DEALLOCATE(tauaerstrat_mois_glo)
+  
+    mth_pre=mth_cur
+
+    ENDIF !--debut ou nouveau mois
+
+    ENDIF !--is_mpi_root
+
+!--total vertical aod at the 5 wavelengths
+    DO wave=1, nwave
+    DO k=1, klev
+    tausum_aero(:,wave,id_strat)=tausum_aero(:,wave,id_strat)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
+    ENDDO
+    ENDDO
+
+!--weighted average for cg, piz and tau, adding strat aerosols on top of tropospheric ones
+    DO band=1, nbands
+!--anthropogenic aerosols bands 1 and 2
+    cg_aero(:,:,3,band)  = ( cg_aero(:,:,3,band)*piz_aero(:,:,3,band)*tau_aero(:,:,3,band) +          &
+                             cg_strat(band)*piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /  &
+                             MAX( piz_aero(:,:,3,band)*tau_aero(:,:,3,band) +                         &
+                                  piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:), 1.e-15 )
+    piz_aero(:,:,3,band)  = ( piz_aero(:,:,3,band)*tau_aero(:,:,3,band) +                             &
+                              piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /                &
+                              MAX( tau_aero(:,:,3,band) + alpha_strat(band)*tau_aer_strat(:,:), 1.e-15 )
+    tau_aero(:,:,3,band)  = tau_aero(:,:,3,band) + alpha_strat(band)*tau_aer_strat(:,:)
+!--natural aerosols bands 1 and 2
+    cg_aero(:,:,2,band)  = ( cg_aero(:,:,2,band)*piz_aero(:,:,2,band)*tau_aero(:,:,2,band) +          &
+                             cg_strat(band)*piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /  &
+                             MAX( piz_aero(:,:,2,band)*tau_aero(:,:,2,band) +                         &
+                                  piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:), 1.e-15 )
+    piz_aero(:,:,2,band)  = ( piz_aero(:,:,2,band)*tau_aero(:,:,2,band) +                             & 
+                              piz_strat(band)*alpha_strat(band)*tau_aer_strat(:,:) ) /                &
+                              MAX( tau_aero(:,:,2,band) + alpha_strat(band)*tau_aer_strat(:,:),1.e-15 )
+    tau_aero(:,:,2,band)  = tau_aero(:,:,2,band) + alpha_strat(band)*tau_aer_strat(:,:)
+    ENDDO
+
+end subroutine readaerosolstrato
Index: LMDZ5/branches/testing/libf/phylmd/screenc.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 1795)
@@ -22,5 +22,5 @@
 ! klon----input-I- dimension de la grille physique (= nb_pts_latitude X nb_pts_longitude)
 ! knon----input-I- nombre de points pour un type de surface
-! nsrf----input-I- indice pour le type de surface; voir indicesol.h
+! nsrf----input-I- indice pour le type de surface; voir indice_sol_mod.F90
 ! zxli----input-L- TRUE si calcul des cdrags selon Laurent Li
 ! speed---input-R- module du vent au 1er niveau du modele
Index: LMDZ5/branches/testing/libf/phylmd/screenp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/screenp.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/screenp.F90	(revision 1795)
@@ -22,5 +22,5 @@
 ! klon----input-I- dimension de la grille physique (= nb_pts_latitude X nb_pts_longitude)
 ! knon----input-I- nombre de points pour un type de surface
-! nsrf----input-I- indice pour le type de surface; voir indicesol.h
+! nsrf----input-I- indice pour le type de surface; voir indice_sol_mod.F90
 ! speed---input-R- module du vent au 1er niveau du modele
 ! tair----input-R- temperature de l'air au 1er niveau du modele
Index: LMDZ5/branches/testing/libf/phylmd/soil.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/soil.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/soil.F90	(revision 1795)
@@ -7,4 +7,6 @@
   USE dimphy
   USE mod_phys_lmdz_para
+  USE indice_sol_mod
+
   IMPLICIT NONE
 
@@ -52,5 +54,4 @@
   INCLUDE "YOMCST.h"
   INCLUDE "dimsoil.h"
-  INCLUDE "indicesol.h"
   INCLUDE "comsoil.h"
   INCLUDE "iniprint.h"
